// Slickworm
// Copyright (c) 2002-2004, Michel O'Brien.
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//  1. Redistributions of source code must retain the above copyright notice,
//     this list of conditions and the following disclaimer.
//  2. Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//  3. Neither the names of the copyright holders nor the names of its
//     contributors may be used to endorse or promote products derived from this
//     software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
// IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#ifndef VORBIS_LOADER_H
#define VORBIS_LOADER_H

#if defined(USE_SOUND)

#include <string>

//! Loads an ogg vorbis buffer given it's filename.
/*!
    Loads an ogg vorbis file. buffer is a pointer to an already allocated buffer of 
    size buffer_size. If the number of bytes in the ogg vorbis stream is larger than
    buffer_size then only buffer_size number of bytes are written to the buffer.
    If the size of the sample is shorter than the buffer buffer_size will be set to
    the actual length of the sample.
    frequency should be 0 initially. after calling this function it will be set to
    the frequency of the ogg vorbis stream.
    stereo is set to true if the stream has 2 or more channels. otherwise it's set
    to false.
*/
void load_vorbis(std::string filename, unsigned char* buffer, 
                int& buffer_size, int& frequency, bool& stereo);

#endif //defined(USE_SOUND)
#endif // VORBIS_LOADER_H

